/******************************************************************************
 * QUANTA - A toolkit for High Performance Data Sharing
 * Copyright (C) 2003 Electronic Visualization Laboratory,  
 * University of Illinois at Chicago
 *
 * This library is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either Version 2.1 of the License, or 
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser Public License along
 * with this library; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Direct questions, comments etc about Quanta to cavern@evl.uic.edu
 *****************************************************************************/

#include <QUANTA/QUANTAmisc_observer_c.hxx>
#include <stdio.h>

class Player : public QUANTAmisc_subject_c
{
public:
	char m_name[100];
	void move();

};

void Player::move()
{
	notify();
};

class Watcher : public QUANTAmisc_observer_c
{

	void update(QUANTAmisc_subject_c *);

};

void Watcher::update(QUANTAmisc_subject_c *s)
{
	printf("Watcher reacting to %s\n",((Player *)s)->m_name);
};

int
main()
{
	Player Player1,Player2;
	Watcher Watcher1;

	strcpy(Player1.m_name,"Player1");
	strcpy(Player2.m_name,"Player2");

	Player1.attach(&Watcher1);
	Player2.attach(&Watcher1);

	Player1.move();
	//move() calls notify() and Watcher reacts accordingly by calling its update method.

	Player2.move();
	//move() calls notify() and Watcher reacts accordingly by calling its update method..

    return 1;
}

