/******************************************************************************
 * QUANTA - A toolkit for High Performance Data Sharing
 * Copyright (C) 2003 Electronic Visualization Laboratory,  
 * University of Illinois at Chicago
 *
 * This library is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either Version 2.1 of the License, or 
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser Public License along
 * with this library; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Direct questions, comments etc about Quanta to cavern@evl.uic.edu
 *****************************************************************************/

#ifndef _TEST_OBJ_H
#define _TEST_OBJ_H


//
// class that wraps an int for stream transport
//
class TestObj : public QUANTAnet_serializable_c
{
	public:
		TestObj(int data) : QUANTAnet_serializable_c()
		{
			_data = data;
			setDataSize(sizeof_int());
		}
		
		TestObj(void) : QUANTAnet_serializable_c(sizeof_int()) {}
		~TestObj(void) {}
		
		void readObjectStream(char *buf)
		{
			// function calls from QUANTAnet_datapack_c
			initUnpack(buf, getDataSize());
			unpackInt(&_data);
		}
		
		void writeObjectStream(char *buf)
		{
			// function calls from QUANTAnet_datapack_c
			initPack(buf, getDataSize());
			packInt(_data);
		}
		
		int getData(void) { return _data; }
		void setData(int d) { _data = d; }

	
	private:
		int _data;

};

#endif
