/******************************************************************************
 * QUANTA - A toolkit for High Performance Data Sharing
 * Copyright (C) 2003 Electronic Visualization Laboratory,  
 * University of Illinois at Chicago
 *
 * This library is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either Version 2.1 of the License, or 
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser Public License along
 * with this library; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Direct questions, comments etc about Quanta to cavern@evl.uic.edu
 *****************************************************************************/

#include <QUANTA/QUANTA.hxx>
#include "TestObj.hxx"


int main(int argc, char *argv[])
{
	TestObj *obj;
	QUANTAnet_objectInputStreamUdp_c *stream;
	
	QUANTAinit();

	// create a new stream object with a null network connection
	stream = new QUANTAnet_objectInputStreamUdp_c(9999);
	
	// read an object from the stream and print the results 
	obj = new TestObj();
	while(stream->readObject(obj) == 0)
	{
		// sleep this process to not take up too much cpu resource
		QUANTAusleep(10000);
	}

	printf("Received data: %d\n", obj->getData());

	// shutdown
	delete obj;
	stream->close();
	QUANTAexit();
	
	return 1;
}
