/******************************************************************************
 * QUANTA - A toolkit for High Performance Data Sharing
 * Copyright (C) 2003 Electronic Visualization Laboratory,  
 * University of Illinois at Chicago
 *
 * This library is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either Version 2.1 of the License, or 
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser Public License along
 * with this library; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Direct questions, comments etc about Quanta to cavern@evl.uic.edu
 *****************************************************************************/

#include <QUANTA/QUANTA.hxx>

#ifdef WIN32
#include <iostream>
#else
#include <iostream.h>
#endif

int main( int a_iArgc, char *a_pcArgv[] )
{
  if( a_iArgc != 5 )
    {
      printf("usage: %s <remote host> <remote port> <psocket size> <send buffer size>\n",a_pcArgv[0]);
      exit(1);
    }
  char *pcRemoteName = a_pcArgv[1];
  int iRemotePort = atoi( a_pcArgv[2] );
  int iPSocketSize = atoi( a_pcArgv[3] );
  int iBufferSize = atoi( a_pcArgv[4] );

  char *pcBuffer = new char[iBufferSize];

  QUANTAinit();

  memset( pcBuffer, 65, iBufferSize );

  QUANTAnet_parallelTcpClient_c client;

  cout << "Trying to Connect!" << endl;

  if (client.connectToServer(pcRemoteName, iRemotePort, iPSocketSize) ==
          QUANTAnet_parallelTcpClient_c::FAILED) {
      cout << "cannot connect to the server " << pcRemoteName << endl;
      exit(1);
  }

  cout << "Connected" << endl;
  
  int j=0;
  while (1)
  {
    j++;
    client.write( pcBuffer, &iBufferSize );
    printf("\nLoop no: a%d", j);
    }
  cout << "Done Sending" << endl;

  delete[] pcBuffer;
  return 1;
}

  
