/******************************************************************************
 * QUANTA - A toolkit for High Performance Data Sharing
 * Copyright (C) 2003 Electronic Visualization Laboratory,  
 * University of Illinois at Chicago
 *
 * This library is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either Version 2.1 of the License, or 
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser Public License along
 * with this library; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Direct questions, comments etc about Quanta to cavern@evl.uic.edu
 *****************************************************************************/

#include "QUANTA.hxx"

int main(int argc, char** argv)
{
	QUANTAinit();

	QUANTAnet_remoteParallelFileIOServer64_c server;

	if (argc > 1 && argc < 3) {
		printf("Usage: server [NeighborServerName CacheLocally]\n");
		printf("NeighborServerName: Valid internet address of a host you want to connect to if files\n");
		printf("                    do not exist in this machine\n");
		printf("CacheLocally:       0 or 1. 0 won't save the file downloaded from the NeighborServerName\n");
		printf("                    locally for later use. 1 will save the downloaded file.\n");
		exit(1);
	}
	else {
		if (argc > 1) {
		    int cache = atoi(argv[2]);
		    printf("argv[2] = %d\n", cache);
			server.init(QUANTAnet_remoteParallelFileIOServer64_c::DEFAULT_PORT, argv[1], 
                        QUANTAnet_remoteParallelFileIOServer64_c::DEFAULT_PORT, cache);
		}
		else 
			server.init();
	}

	while(1) {
		// Set it up so that a new thread is spawned for each
		// client's request.
		server.process(QUANTAnet_remoteParallelFileIOServer64_c::NON_THREADED);
		QUANTAsleep(1);
	}
    return 1;
}
