/******************************************************************************
 * QUANTA - A toolkit for High Performance Data Sharing
 * Copyright (C) 2003 Electronic Visualization Laboratory,  
 * University of Illinois at Chicago
 *
 * This library is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either Version 2.1 of the License, or 
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser Public License along
 * with this library; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Direct questions, comments etc about Quanta to cavern@evl.uic.edu
 *****************************************************************************/

#include <QUANTA/QUANTA.hxx>

int main(int argc, char ** argv)
{
	QUANTAinit();


	QUANTAnet_rpcCaller_c rpc1, rpc2;
	char* retdata;
	int retlen;

	rpc1.init("DO and REPLY",argv[1]);
	rpc1.call("RPC1 CLIENT CALLING", 20, &retdata, &retlen);
	printf("Reply: %s\n",retdata);

    //for an instantaneous display of performance monitoring statistics
    rpc1.showStats("Monitoring_in_RPC1", "Some_do_and_reply_data");

	rpc2.init("DO ONCE",argv[1]);
	rpc2.call1way("RPC2 CLIENT CALLING", 20);
        return 1;

}
