/******************************************************************************
 * QUANTA - A toolkit for High Performance Data Sharing
 * Copyright (C) 2003 Electronic Visualization Laboratory,  
 * University of Illinois at Chicago
 *
 * This library is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either Version 2.1 of the License, or 
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser Public License along
 * with this library; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Direct questions, comments etc about Quanta to cavern@evl.uic.edu
 *****************************************************************************/

#include <QUANTA/QUANTA.hxx>

int doAndReplyCallback(char* indata, int inlen,
		       char **outdata, int *outlen)
{
	printf("Doing and replying: %s\n", indata);
	*outdata = new char[256];
	strcpy(*outdata,"HELLO THERE\n");
	*outlen = strlen(*outdata) + 1;
	return 0;
}

int doOnceCallback(char* indata, int inlen,
		       char **outdata, int *outlen)
{
	printf("Doing once: %s\n",indata);
	return 0;
}

int main(int argc, char** argv)
{
	QUANTAinit();
    QUANTAnet_rpcManager_c rpcManager;
	rpcManager.init();
	rpcManager.manage("DO and REPLY", doAndReplyCallback);
	rpcManager.manage("DO ONCE", doOnceCallback);

	while(1) {
		rpcManager.process();

        //For an instantaneous display of performance monitoring stats
        rpcManager.showStats("Monitoring_in_rpcManager", "Some_remote_data");

        QUANTAsleep(1);
	}
	return 0;
}
