/******************************************************************************
 * QUANTA - A toolkit for High Performance Data Sharing
 * Copyright (C) 2003 Electronic Visualization Laboratory,  
 * University of Illinois at Chicago
 *
 * This library is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either Version 2.1 of the License, or 
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser Public License along
 * with this library; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Direct questions, comments etc about Quanta to cavern@evl.uic.edu
 *****************************************************************************/

#include <QUANTA/QUANTA.hxx>

int main(int argc, char *argv[])
{
	unsigned int port = 9753;

	// parse command line for port option
	for(int i = 0; i < argc; i++) 
	{
		if(*argv[i]++ == '-') 
		{
			if(*argv[i] == 'p')
				port = atoi(argv[++i]);
			else
				fprintf(stderr, "%s command not supported\n", argv[i]);
		}
	}
//	fprintf(stdout, "host = %s, port = %d\n", host, port);

	QUANTAinit();
	QUANTAnet_barrierTcp_c *barrier = new QUANTAnet_barrierTcp_c("test", 2, port, true);

	while(true)
		QUANTAsleep(1);

	QUANTAexit();
	return 1;
}
