/******************************************************************************
 * QUANTA - A toolkit for High Performance Data Sharing
 * Copyright (C) 2003 Electronic Visualization Laboratory,  
 * University of Illinois at Chicago
 *
 * This library is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either Version 2.1 of the License, or 
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser Public License along
 * with this library; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Direct questions, comments etc about Quanta to cavern@evl.uic.edu
 *****************************************************************************/

//Demo program that creates a thread and takes care of mutual exclusion

#include <QUANTA/QUANTA.hxx>

#ifdef WIN32
#include <string.h>
#else
#include <strings.h>
#endif
#include <stdlib.h>

void* threadedFunction(void* data);

QUANTAts_mutex_c quantaMutex;

int main(int argc, char** argv)
{
	QUANTAinit();
    QUANTAts_thread_c quantaThread;
    
    int *count = new int;
    *count =1;
    
    //This is just to turn the debugstat on for the mutex - this will print messages for debugging(turned off by default)
    
    quantaMutex.setMutexDebug(QUANTAts_mutex_c::DEBUG_ON);
    
    //loop to create 5 threads
	while(1) {
    quantaThread.create(threadedFunction, (void*) count);         
    (*count)++;
    QUANTAsleep(1);
	
    //exit if 5 threads have been created
    if (*count > 5)
        exit(0);            
	}
    return 1;

}

void* threadedFunction(void* data)
{
    quantaMutex.lock();               //lock mutex
    int* count = (int*) data;                   
    printf("\nThread number %d\n", *count);
    quantaMutex.unlock();            //unlock mutex
    return NULL;
}
