/******************************************************************************
 * QUANTA - A toolkit for High Performance Data Sharing
 * Copyright (C) 2003 Electronic Visualization Laboratory,
 * University of Illinois at Chicago
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either Version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Lesser Public License along
 * with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Direct questions, comments etc about Quanta to cavern@evl.uic.edu
 *****************************************************************************/

#include <QUANTA/QUANTA.hxx>

#define CYCLES 5


class Cat : public QUANTAts_thread_c
{
	public:
		Cat(void) : QUANTAts_thread_c() { create(); }
		virtual ~Cat(void) {}

	protected:
		virtual void run(void)
		{
			static int c = 0;
//			while(isRunning())
			for(int i = 0; i < CYCLES; i++)
			{
				fprintf(stdout, "cat cycle count = %d\n", c);
				c++;
				QUANTAsleep(2); // its a slow, fat cat
			}
		}
};


class Mouse : public QUANTAts_thread_c
{
	public:
		Mouse(void) : QUANTAts_thread_c() { create(); }
		virtual ~Mouse(void) {}
		
//		void test(void) { printf("mouse::test()\n"); }

	protected:
		virtual void run(void)
		{
			static int c = 0;
//			while(isRunning())
			for(int i = 0; i < CYCLES; i++)
			{
				fprintf(stdout, "mouse cycle count = %d\n", c);
				c++;
				QUANTAsleep(1);
			}
		}
};


int main(int argc, char *argv[])
{
	QUANTAinit();
	Cat *cat = new Cat();
	Mouse *mouse = new Mouse();

	for(int i = 0; i < CYCLES; i++)
	{
		fprintf(stdout, "main cycle count = %d\n", i);
		QUANTAsleep(1);
	}


	cat->join();
	mouse->join();

	QUANTAexit();
	return 1;
}
