/******************************************************************************
 * QUANTA - A toolkit for High Performance Data Sharing
 * Copyright (C) 2003 Electronic Visualization Laboratory,  
 * University of Illinois at Chicago
 *
 * This library is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either Version 2.1 of the License, or 
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser Public License along
 * with this library; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Direct questions, comments etc about Quanta to cavern@evl.uic.edu
 *****************************************************************************/
#include <QUANTA/QUANTAglobals.hxx>

#ifdef WIN32
#ifndef __HAVE_WINSOCK2_H
#include <winsock2.h>
#define __HAVE_WINSOCK2_H
#endif /* __HAVE_WINSOCK2_H */
#else
#if HAVE_UNISTD_H
#include <unistd.h>
#endif
#endif

#ifdef QUANTA_STRCASECMP 
extern int strcasecmp(const char *first, const char *second) 
{ 
	while(*first && *second)
	{ 
		if(toupper((int)*first) != toupper((int)*second)) 
			break; 
		first++; 
		second++; 
	} 
	return toupper((int)*first) - toupper((int)*second); 
}
#endif

void QUANTAsleep(const unsigned int& seconds)
{
#ifdef WIN32
  Sleep(seconds * 1000);
#else
#if HAVE_SLEEP
  sleep(seconds);
#endif
#endif
}

void QUANTAusleep(const unsigned int& microseconds)
{
#ifdef WIN32
  Sleep(microseconds / 1000);
#else
#if HAVE_USLEEP
  usleep(microseconds);
#endif
#endif
}
