/******************************************************************************
 * QUANTA - A toolkit for High Performance Data Sharing
 * Copyright (C) 2003 Electronic Visualization Laboratory,  
 * University of Illinois at Chicago
 *
 * This library is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either Version 2.1 of the License, or 
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser Public License along
 * with this library; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Direct questions, comments etc about Quanta to cavern@evl.uic.edu
 *****************************************************************************/

#include <QUANTA/QUANTAnet_barrierBase_c.hxx>


QUANTAnet_barrierBase_c::QUANTAnet_barrierBase_c(char *key_id, int block_count, unsigned int
port, int verbose)
	: QUANTAts_thread_c()
{
	if(port > 0)
		_port = port;
// else if(getenv("QUANTA_BARRIER_PORT"))
//    _port = atoi(getenv("QUANTA_BARRIER_PORT"));
	else
		_port = 5973; // default port

	_key_id = key_id;
	_block_count = block_count;
	_wait_count = 0;
	_verbose = verbose;
}


QUANTAnet_barrierBase_c::~QUANTAnet_barrierBase_c(void)
{
	delete _key_id;
}



/******************************************************************************/

QUANTAnet_barrierNodeBase_c::QUANTAnet_barrierNodeBase_c(char *host, unsigned int port)
{
 if(host)
    _host = strdup(host);
// else if(getenv("QUANTA_BARRIER_HOST"))
//    _host = strdup(getenv("QUANTA_BARRIER_HOST"));
 else
//    _host = "localhost";
    _host = "127.0.0.1";


 if(port > 0)
    _port = port;
// else if(getenv("QUANTA_BARRIER_PORT"))
//    _port = atoi(getenv("QUANTA_BARRIER_PORT"));
 else
    _port = 5973; // default port

}


QUANTAnet_barrierNodeBase_c::~QUANTAnet_barrierNodeBase_c(void)
{
	delete _host;
	delete [] _recvline;
}
