/******************************************************************************
 * QUANTA - A toolkit for High Performance Data Sharing
 * Copyright (C) 2003 Electronic Visualization Laboratory,  
 * University of Illinois at Chicago
 *
 * This library is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either Version 2.1 of the License, or 
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser Public License along
 * with this library; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Direct questions, comments etc about Quanta to cavern@evl.uic.edu
 *****************************************************************************/

#include <QUANTA/QUANTAnet_objectStreamUdp_c.hxx>


QUANTAnet_objectOutputStreamUdp_c::QUANTAnet_objectOutputStreamUdp_c(char *host, int port)
	: QUANTAnet_objectStreamBaseUdp_c(host, port)
{
}


QUANTAnet_objectOutputStreamUdp_c::~QUANTAnet_objectOutputStreamUdp_c(void)
{
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////


QUANTAnet_objectInputStreamUdp_c::QUANTAnet_objectInputStreamUdp_c(int port)
	: QUANTAnet_objectStreamBaseUdp_c()
{
	_server = new QUANTAnet_udp_c();
	if(_server->init(port) == 0)
	{
		printf("QUANTAnet_objectInputStreamUdp_c() - Error: Can not start server\n");
		exit(1);
	}
	
	setNetworkClient(_server);
}


QUANTAnet_objectInputStreamUdp_c::QUANTAnet_objectInputStreamUdp_c(void)
	: QUANTAnet_objectStreamBaseUdp_c()
{
	_server = NULL;
}


QUANTAnet_objectInputStreamUdp_c::~QUANTAnet_objectInputStreamUdp_c(void)
{
	delete _server;
}


QUANTAnet_udp_c *QUANTAnet_objectInputStreamUdp_c::getNetworkServer(void)
{
	if(_server == NULL)
		return NULL;
	else
		return _server;
}


void QUANTAnet_objectInputStreamUdp_c::setNetworkServer(QUANTAnet_udp_c *server)
{
	if(server != NULL)
		_server = server;
}


/*
void QUANTAnet_objectInputStreamUdp_c::close(void)
{
	_client->close();
	_server->close();
}
*/
