/******************************************************************************
 * QUANTA - A toolkit for High Performance Data Sharing
 * Copyright (C) 2003 Electronic Visualization Laboratory,  
 * University of Illinois at Chicago
 *
 * This library is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either Version 2.1 of the License, or 
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser Public License along
 * with this library; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Direct questions, comments etc about Quanta to cavern@evl.uic.edu
 *****************************************************************************/

#include <QUANTA/QUANTAnet_serializable_c.hxx>


QUANTAnet_serializable_c::QUANTAnet_serializable_c(void)
	: QUANTAnet_datapack_c()
{
	_data_size = 0;
}


QUANTAnet_serializable_c::QUANTAnet_serializable_c(unsigned long data_size)
	: QUANTAnet_datapack_c()
{
	_data_size = data_size;
}


QUANTAnet_serializable_c::~QUANTAnet_serializable_c(void)
{
}
		

unsigned long QUANTAnet_serializable_c::getDataSize(void)
{
	return _data_size;
}


void QUANTAnet_serializable_c::setDataSize(unsigned long data_size)
{
	_data_size = data_size;
}
