/******************************************************************************
 * QUANTA - A toolkit for High Performance Data Sharing
 * Copyright (C) 2003 Electronic Visualization Laboratory,  
 * University of Illinois at Chicago
 *
 * This library is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either Version 2.1 of the License, or 
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public 
 * License for more details.
 * 
 * You should have received a copy of the GNU Lesser Public License along
 * with this library; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Direct questions, comments etc about Quanta to cavern@evl.uic.edu
 *****************************************************************************/

#include "QUANTA.hxx"
#ifdef WIN32
#include <winsock.h>
#else
#include <unistd.h>
#endif
#include "QUANTAnet_perfClient_c.hxx"

#define BUFFER_SIZE 1024
int
main(int argc, char** argv)
{
	QUANTAinit();

	QUANTAnet_perfDaemonClient_c aClient(1); // Specify this is a perfclient

	if (argc == 1) {
		printf("Usage: %s <perfdaemon_ip>\n",argv[0]);
		exit(1);
	}

	if (aClient.connectToServer(argv[1])  == QUANTAnet_perfDaemonClient_c::FAILED) {
		printf("Cannot connect to perfdaemon\n");
		exit(1);
	}
	
	/// Enter a loop and read incoming netlogger traces.
	char *data = new char[BUFFER_SIZE];
	int size = BUFFER_SIZE;
    printf("\nQOSIMOTO Client waiting for data:\n%s\n",data);
	while(1) {
		data = NULL;
		aClient.read(&data, &size, QUANTAnet_perfDaemonClient_c::NON_BLOCKING);
		if (data) 
        {
			printf("\nQOSIMOTO Client printing data:\n%s\n",data);
			delete data;
		}
	}
	return 0;
}

