#include "FormatParser.h"

#include <string.h>

static const int MAX_TOKENS = 22;

static TOKENSTRUCT tokens[MAX_TOKENS] = {
	{ 'a', TOKEN_a }, { 'A', TOKEN_A }, { 'b', TOKEN_b }, { 'B', TOKEN_B },
	{ 'c', TOKEN_c }, { 'd', TOKEN_d }, { 'H', TOKEN_H }, { 'I', TOKEN_I },
	{ 'j', TOKEN_j }, { 'm', TOKEN_m }, { 'M', TOKEN_M }, { 'p', TOKEN_p }, 
	{ 'S', TOKEN_S }, { 'U', TOKEN_U }, { 'w', TOKEN_w }, { 'W', TOKEN_W },
	{ 'x', TOKEN_x }, { 'X', TOKEN_X }, { 'y', TOKEN_y }, { 'Y', TOKEN_Y },
	{ 'z', TOKEN_z }, { '%', TOKEN_PERCENT }
};

CFormatParser::CFormatParser(const char* FormatString)
{ 
	if (FormatString) {
		Format = new char[strlen(FormatString) + 1]; 

		if (Format) strcpy(Format, FormatString);
		tempFormat = Format;
	}
}

void CFormatParser::SetFormatString(char* FormatString)
{
	if (FormatString) {
		Format = new char[strlen(FormatString) + 1];

		if (Format) strcpy(Format, FormatString);
		tempFormat = Format;
	}
}

TOKEN CFormatParser::GetNextToken(char* TokenValue)
{
	bool tempTokenValueSet = false;
	char* tempTokenValue = TokenValue;
	*tempTokenValue = '\0';
	
	if (tempFormat) {
		while (*tempFormat) {
			if (*tempFormat == '%') {
				if (tempTokenValueSet) {
					*tempTokenValue = '\0';
					return TOKEN_VALUE;
				}
				else {
					tempFormat++;
					if (*tempFormat == '\0') return TOKEN_ERROR;
					else {
						for (int i = 0; i < MAX_TOKENS; i++) {
							if (tokens[i].tokenChar == *tempFormat) {
								tempFormat++;
								return tokens[i].token;
							}
						}
						return TOKEN_ERROR;
					}
				}
			}
			else {
				*tempTokenValue++ = *tempFormat++;
				tempTokenValueSet = true;
			}
		}
	}
	if (tempTokenValueSet) {
		*tempTokenValue = '\0';
		return TOKEN_VALUE;
	}
	return TOKEN_EMPTY;
}