#ifdef _WIN32_WCE
#include <windows.h>
#include <stdlib.h>
#include "tempnam.h"

static char tempFileName[MAX_PATH];

static UINT GetTempFileNameA(LPCSTR lpPathName, LPCSTR lpPrefixString, 
	  						 UINT uUnique, LPSTR lpTempFileName)
{
	BOOL bUsed;
	UINT result;
	TCHAR wPathName[MAX_PATH], wPrefixString[MAX_PATH], wTempFileName[MAX_PATH];

    if (MultiByteToWideChar(CP_ACP, MB_ERR_INVALID_CHARS, 
	                    lpPathName, -1, wPathName, MAX_PATH) == 0) return 0;
    if (MultiByteToWideChar(CP_ACP, MB_ERR_INVALID_CHARS, 
	                    lpPrefixString, -1, wPrefixString, MAX_PATH) == 0) return 0;

	result = GetTempFileName(wPathName, wPrefixString, uUnique, wTempFileName);
	if (result == 0) return 0;
	if (WideCharToMultiByte(CP_ACP, 0, wTempFileName, -1, 
	                        lpTempFileName, MAX_PATH, NULL, &bUsed) == 0) return 0;
	return result;
}

char* tempnam(char *dir, char *prefix)
{
    if (GetTempFileNameA(dir, prefix, 0, tempFileName)) return tempFileName;
	return NULL;
}
#endif