#ifndef __TIME_H_
#define __TIME_H_

#ifndef _TM_DEFINED
struct tm {
	int tm_sec;     /* seconds after the minute - [0,59] */
	int tm_min;     /* minutes after the hour - [0,59] */
	int tm_hour;    /* hours since midnight - [0,23] */
	int tm_mday;    /* day of the month - [1,31] */
	int tm_mon;     /* months since January - [0,11] */
	int tm_year;    /* years since 1900 */
	int tm_wday;    /* days since Sunday - [0,6] */
	int tm_yday;    /* days since January 1 - [0,365] */
	int tm_isdst;   /* daylight savings time flag */
};
#define _TM_DEFINED
#endif

#ifdef __cplusplus
extern "C"
{
#endif

void InitTime();
struct tm *gmtime(const time_t* timer);
size_t strftime(char *s, size_t maxsize, const char *format, const struct tm *timeptr);

#ifdef __cplusplus
}
#endif

#endif