#include "unicodecvt.h"

LPWSTR AnsiToUnicode(LPSTR lpszAnsiStr, UINT* length)
{
    LPWSTR lpWideStr;

	if (lpszAnsiStr) {
	    *length = MultiByteToWideChar(CP_ACP, MB_ERR_INVALID_CHARS,
									  lpszAnsiStr, -1, NULL, 0);
		if (*length == 0) return NULL;
		lpWideStr = (WCHAR*) malloc((*length + 1) * sizeof(WCHAR));
		if (lpWideStr == NULL) return NULL;
		if (MultiByteToWideChar(CP_ACP, MB_ERR_INVALID_CHARS, 
			                    lpszAnsiStr, -1, lpWideStr, *length)) {
			*length *= sizeof(WCHAR);  // size in bytes
			return lpWideStr;
		}
	}
	return NULL;
}

LPSTR UnicodeToAnsi(LPWSTR lpszWideStr, UINT* length)
{
    LPSTR lpAnsiStr;
	BOOL bUsed;

	if (lpszWideStr) {
	    *length = WideCharToMultiByte(CP_ACP, 0, lpszWideStr, -1, NULL, 0, 
			                          NULL, &bUsed);
		if (*length == 0) return NULL;
		lpAnsiStr = (char*) malloc((*length + 1) * sizeof(char));
		if (lpAnsiStr == NULL) return NULL;
		if (WideCharToMultiByte(CP_ACP, 0, lpszWideStr, -1, lpAnsiStr, *length, 
			                    NULL, &bUsed)) {
			return lpAnsiStr;
		}
	}
	return NULL;
}